﻿import com.delfiweb.error.*//ErrorDispatcher



/**
* Crée les textes du menu XML
* 
* @class Parser
* @author DELOISON Matthieu
* @version 0.1
*/
class Parser
{
	private var _xml:String


	private static var _instance:Parser=null
	private var _isDebug
	private var _isLocal
	
	
	
	private function Parser()
	{
		_xml=""

		_isDebug=PMain.instance.isDebug
		_isLocal = PMain.instance.isLocal

		
	}
	
	public static function getInstance ():Parser
	{
		if(Parser._instance==null)
		{
			Parser._instance=new Parser()
		}
		return Parser._instance
	}
	
		
	
	/*----------------------------------------------------------*/
	/*------------- Décode le XML ------------------------------*/
	/*----------------------------------------------------------*/
	
	
	
	// fonction : décode le fichier XML des chaines de caractères
	function parseXML (xml)
	{
		//if (_isDebug) Debugger.output(xml)
		// si le xml n'est pas défini 
	   if(!xml) { throw new DError ("Aucun paramètre n'a été transmis à la fonction.","parser",0); } 
	   // si il n'est pas du bon type 
	   //else if(typeof xml != "string") { throw new DError ("Le paramètre transmis n'est pas une chaîne","parser",0); } 
	   // a priori c'est bon 
	   else 
	   {
			XML.prototype.ignoreWhite = true
			var n = new XML(xml); 
			
			// si il est mal formé sur le premier noeud on se retrouve avec un xml vide 
			//if(n.toString() == "") { throw new DError ("La chaine1 xml transmise est mal formé","parser",0); } 
			  
			// on va faire nos vrai tests sur le premier fils 
			var ficxml = n.firstChild; 
			// si le fils était malformé 
			if(ficxml.toString() == "") { throw new DError ("La chaine2 xml transmise est mal formé","parser",0); } 
			// on parse le noeud principal 
			
			//ficxml = n.childNodes[1];			
			//ficxml = n.lastChild; 
	
			switch(ficxml.nodeName) 
			{ 
				
				 case "texte" :  
				 case "TEXTE" : 					
					var a = new Array();
					_global.Strings = new Array ();
					//_global.Strings = new Array ();
					for(var i=0;i<ficxml.childNodes.length;i++)
					{
						var fils = ficxml.childNodes[i]
						//trace ("fils n° "+i+" : "+fils+" ("+fils.nodeType+", "+fils.nodeName+")");
						
						if(fils.nodeType==1)
						{
							// récupère l'index du tableau
							var index = [fils.attributes.id];
							// récupère la chaine correspondante
							var tmp= fils.firstChild.nodeValue.split ("\\n").join ("\n")
							
							_global.Strings[index] = tmp;
						}
					}
					break;
					  
				default :  
					  throw new DError ("Cas non-répertorié - String","parser",1); 
					  break;	  
			}
			PMain.instance.contructOn();
	   }
	   

	}
	
	
	// fonction : décode les flux RSS
	function parseXMLrss (xml, numNews)
	{
		
		
		// si le xml n'est pas défini 
	   if(!xml) { throw new DError ("Aucun paramètre n'a été transmis à la fonction.","parser",0); } 
	   // si il n'est pas du bon type 
	   //else if(typeof xml != "string") { throw new DError ("Le paramètre transmis n'est pas une chaîne","parser",0); } 
	   // a priori c'est bon 
	   else 
	   {
		   
			XML.prototype.ignoreWhite = true
			var n = new XML(xml); 
			var rss = new XML(xml); 
			
			// si il est mal formé sur le premier noeud on se retrouve avec un xml vide 
			if(n.toString() == "") { throw new DError ("La chaine1 xml transmise est mal formé","parser",0); } 
			  
			// on va faire nos vrai tests sur le premier fils 
			var ficxml = n.firstChild; 
			
			// si le fils était malformé 
			if(ficxml.toString() == "") { throw new DError ("La chaine2 xml transmise est mal formé","parser",0); } 
			
			/*--- traitement des news ---*/
			if ( rss.firstChild.nextSibling == null ) 
			{
				rss = new XML(rss.firstChild.childNodes);
			}
			
			var channel = new XML(rss.firstChild);
			
			var tempRSS = rss.firstChild;
			
			for ( var i=0; i<tempRSS.childNodes.length; i++ ) 
			{
				/*--- récupère les entêtes du site ---*/
				if(tempRSS.childNodes[i].nodeName == "title")
				{
					var titreSite:String = tempRSS.childNodes[i].childNodes;
					//trace("titreSite : "+titreSite)
				}
				else if(tempRSS.childNodes[i].nodeName == "image")
				{
					var urlImage:String = tempRSS.childNodes[i].firstChild.nextSibling.childNodes;
					//trace("urlImage : "+urlImage)
				}
				else if(tempRSS.childNodes[i].nodeName == "link")
				{
					var urlSite:String = tempRSS.childNodes[i].childNodes;
					//trace("urlSite : "+urlSite)
				}
				else if ( tempRSS.childNodes[i].nodeName == "item" ) 
				{
					var item = new XML(tempRSS.childNodes[i]);
					
					/*--- récupère les news du site ---*/
					for ( var j=0; j<item.firstChild.childNodes.length; j++ ) 
					{

						switch ( item.firstChild.childNodes[j].nodeName )
						{
								case "title" :
									var titreNews:String = item.firstChild.childNodes[j].firstChild;
									//trace("titreNews : "+titreNews)
									break;
								case "link" :
									var urlNews:String = item.firstChild.childNodes[j].firstChild;
									//trace("urlNews : "+urlNews)
									break;
								case "dc:date" :
									var dateNews:String = item.firstChild.childNodes[j].firstChild;
									//trace("dateNews : "+dateNews)
									var my_str:String = dateNews.toString();
									var my_array:Array = my_str.split("-");
									
									var my_str2:String = my_array[2].toString();
									var my_array2:Array = my_str2.split("T");
													
									dateNews = my_array2[0]+"-"+my_array[1];

									break;
								case "pubDate" :
									var dateNews:String = item.firstChild.childNodes[j].firstChild;
									//trace("dateNews : "+dateNews)
									var my_str:String = dateNews.toString();
									var my_array:Array = my_str.split(" ");
									if(my_array[1] == "") dateNews = my_array[2]+"-"+my_array[3];
									else dateNews = my_array[1]+"-"+my_array[2];
									break;
									
								case "description" :
									var description:String = item.firstChild.childNodes[j].firstChild;
									//trace("urlNews : "+urlNews)
									break;
						}
						
										
					}
					
					_global.RSS[PMain.instance._indexTab] = new FluxRSS (	titreSite,
												urlSite,
												urlImage,
												titreNews,
												urlNews,
												dateNews,
												numNews,
												description
												);
					PMain.instance._indexTab++;
					
					
				}
				
				
		
			}
			
		
	   } // fin du else parse le xml
		
		PMain.instance.afficher(numNews);
	}
	
}
	